



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>详解Paint的setMaskFilter(MaskFilter maskfilter)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">详解Paint的setMaskFilter(MaskFilter maskfilter)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 11:32:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、setMaskFilter(MaskFilter maskfilter)</strong></p>
<p>setMaskFilter(MaskFilter maskfilter)是paint中的方法，它可以用来对图像进行一定的处理。这个方法需要传入一个MaskFilter对象。但MaskFilter类中没有任何实现方法，所以我们就要认识下它的两个子类BlurMaskFilter和EmbossMaskFilter，前者为模糊遮罩滤镜而后者为浮雕遮罩滤镜。</p>
<p><strong>二、BlurMaskFilter</strong></p>
<p><strong>2.1 初识</strong></p>
<p>我们在之前的cardView中讲解到cardview可以设置阴影效果，我先摆出之前文章的图片。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222044410807994.jpg" /></p>
<p>使用BlurMaskFilter可以轻松实现上面的阴影效果。</p>
<div>
<pre class="prettyprint linenums">    @Override<br />
    protected void onDraw(Canvas canvas) {<br />
        super.onDraw(canvas);

        mPaint.setColor(Color.RED);<br />
        // 设置画笔遮罩滤镜  ,传入度数和样式<br />
        <strong>mPaint.setMaskFilter(new BlurMaskFilter(20, BlurMaskFilter.Blur.SOLID));<br />
        </strong>// 画一个矩形<br />
        canvas.drawRect(200, 200, 600, 600, mPaint);<br />
    }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222047037839632.jpg" /></p>
<p>说明：这个方法已经被标注为过时的方法了，如果你的应用启用了硬件加速，你是看不到任何阴影效果的。</p>
<p>如果在AndroidManifest.xml文件中关闭硬件加速那么我们整个应用都将不支持硬件加速，这显然是不科学的，如果可以只针对某个View关闭硬件加速那岂不是很好么？当然，Android也给我们提供了这样的功能，我们可以在View中通过：</p>
<blockquote><p>setLayerType(LAYER_TYPE_SOFTWARE, null);</p></blockquote>
<p>来关闭单个View的硬件加速功能。</p>
<p><strong>2.2 构造函数</strong></p>
<p>BlurMaskFilter只有一个含参的构造函数</p>
<blockquote><p>BlurMaskFilter(float radius, BlurMaskFilter.Blur style)</p></blockquote>
<p>第一个参数：radius很容易理解，值越大我们的阴影越扩散，用过PS的人会很容易理解，其实就是阴影范围。</p>
<p>第二个参数：style表示的是模糊的类型，上面我们用到的是SOLID，其效果就是在图像的Alpha边界外产生一层与Paint颜色一致的阴影效果而不影响图像本身，除了SOLID还有三种，NORMAL,OUTER和INNER。我们来逐个看看效果：</p>
<p><strong>SOLID</strong></p>
<p>其效果就是在图像的Alpha边界外产生一层与Paint颜色一致的阴影效果而不影响图像本身。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222052475029489.jpg" /></p>
<p>因为阴影的颜色是从色块中取出的，也是红色的，所以你感觉不是很舒服，如果阴影是黑色的就好很多了。</p>
<p><strong>NORMAL</strong></p>
<p>会将整个图像模糊掉。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222054167366096.jpg" /></p>
<p><strong>OUTER</strong></p>
<p>会在Alpha边界外产生一层阴影且会将原本的图像变透明。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222056034087474.jpg" /></p>
<p><strong>INNER</strong></p>
<p>会在图像内部产生模糊。可以看见阴影在色块的内部，有种淡淡的浮雕感。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222058421899398.jpg" /></p>
<p>INNER效果其实并不理想，实际应用中我们使用的也少。</p>
<p><strong>2.3 给图片添加阴影</strong></p>
<p>BlurMaskFilter是根据Alpha通道的边界来计算模糊的，如果用它对图片进行处理，你会发现没有任何效果。那么我们如何给图片加一个类似阴影的效果呢？其实很简单，我们可以尝试从Bitmap中获取其Alpha通道，并在绘制Bitmap前先以该Alpha通道绘制一个模糊效果就就行了。最终效果就是阴影图片叠加到原图的下方。</p>
<div>
<pre class="prettyprint linenums">@Override<br />
    protected void onDraw(Canvas canvas) {<br />
        super.onDraw(canvas);

        Bitmap srcBitmap = BitmapFactory.decodeResource(mContext.getResources(), R.drawable.kale);

        // 获取位图的Alpha通道图<br />
        Bitmap shadowBitmap = srcBitmap.extractAlpha();

        mPaint.setColor(Color.DKGRAY);<br />
        // 设置画笔遮罩滤镜 ,传入度数和样式<br />
        mPaint.setMaskFilter(new BlurMaskFilter(10, BlurMaskFilter.Blur.NORMAL));

        // 先绘制阴影<br />
        canvas.drawBitmap(shadowBitmap, 200, 200, mPaint);

        // 画原图<br />
        canvas.drawBitmap(srcBitmap, 200, 200, null);<br />
    }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222106544719902.jpg" /></p>
<p>如果你好奇，底部的阴影图片是什么样子的，我们就不绘制原图，仅仅绘制后面的阴影图片看看。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/651487/201502/222108002992825.jpg" /></p>
<p><strong>三、EmbossMaskFilter</strong></p>
<p><strong>3.1 初识</strong></p>
<p>相对于之前的BlurMaskFilter来说，EmbossMaskFilter的可用性比较低，因为它实现的效果不是很霸气。正如其名，他可以实现一种类似浮雕的效果，说白了就是让你绘制的图像感觉像是从屏幕中&ldquo;凸&rdquo;起来更有立体感一样（在设计软件中类似的效果称之为斜面浮雕）。</p>
<p><strong>3.2 构造函数</strong></p>
<blockquote><p>EmbossMaskFilter(float[] direction, float ambient, float specular, float blurRadius)</p></blockquote>
<p>这里面的各种参数理解起来比较复杂，如果想要详细的了解可以去看：http://blog.csdn.net/aigestudio/article/details/41447349</p>
<p>我这里就不做什么说明了，因为做浮雕的画，找ps就好了。</p>
<h4>说明：本文大部分来自：http://blog.csdn.net/aigestudio/article/details/41316141，我对原文有细小的删减，记录在此作为学习笔记之用。</h4>
<p><strong>From AigeStudio（http://blog.csdn.net/aigestudio）Power by Aige &nbsp;尊重原作者，感谢作者的分享！</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m2xzoq.html">&period;NET平台开源项目速览&lpar;10&rpar;FluentValidation验证组件深入使用&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r4lkm8.html">jq点击显示，再点击隐藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qndx4x8.html">转载&colon;Tomcat的JVM设置和连接数设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gdyv09.html">Eclipse智能提示及快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8klm63q.html">iSCSI配置流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ezprz8.html">tarjan算法求割点cojs 8</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v27e38.html">简单JS实现对表的行的增删</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z12k739.html">C&num; 中使用win32函数 GetScrollInfo返回false 返回引用全是零的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjrye79.html">XCode请求数据中接收类型的后台与前台处理&lpar;本机模拟&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw3ej9.html">Struts2入门项目开发小步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd5drz9.html">bzoj3930&lbrack;CQOI2015&rsqb;选数  容斥原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oxrmj8.html">C&num; foreach 值类型及引用类型迭代变量改变的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2g7n9.html">JDK动态代理（2）--------反射Method的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r54vp7q.html">vue自定义插件-弹框</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllkdj0q.html">docker占满linux磁盘根目录的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w32w0q.html">ubuntu拒绝root用户ssh远程登录解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd0ejj9.html">【IT笔试面试题整理】给定一个数组a&lbrack;N&rsqb;构造数组b &lbrack;N&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vdx3q.html">JDK环境变量的配置1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnpzoeq.html">js中将文件的base64转换成file并上传到服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmowvw9.html">golang学习之slice基本操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8m00zp9.html">详解shape标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw21llq.html">Log4Net 手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zwdjx8.html">Logcat 不显示日志的另一个原因&period; 跟cocos2dx关系不大&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvlxz18.html">Web程序员开发App系列 - 认识HBuilder</a>
			</li>
						<li><a href="https://www.batexi.com/a/495o6v68.html">bootstrap插件学习-bootstrap&period;alert&period;js</a>
			</li>
						<li><a href="https://www.batexi.com/a/390gwgo8.html">分享一套精美的现代 UI  PSD 工具包【免费下载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96vojy8.html">sitemesh学习笔记&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j5z148.html">Web性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw3jzr9.html">Sprint 3计划</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ezyxk8.html">0422 Step2-FCFS调度</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
